(最大生成树) hdu 3367

Pseudoforest

Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)
Total Submission(s): 1957    Accepted Submission(s): 756

Problem Description

In graph theory, a pseudoforest is an undirected graph in which every connected component has at most one cycle. The maximal pseudoforests of G are the pseudoforest subgraphs of G that are not contained within any larger pseudoforest of G. A pesudoforest is larger than another if and only if the total value of the edges is greater than another one’s.

Input

The input consists of multiple test cases. The first line of each test case contains two integers, n(0 < n <= 10000), m(0 <= m <= 100000), which are the number of the vertexes and the number of the edges. The next m lines, each line consists of three integers, u, v, c, which means there is an edge with value c (0 < c <= 10000) between u and v. You can assume that there are no loop and no multiple edges.
The last test case is followed by a line containing two zeros, which means the end of the input.

Output

Output the sum of the value of the edges of the maximum pesudoforest.

Sample Input

3 3
0 1 1
1 2 1
2 0 1
4 5
0 1 1
1 2 1
2 3 1
3 0 1
0 2 2
0 0

Sample Output

3
5

题意:

在图论中,如果一个森林中有很多连通分量,并且每个连通分量中至多有一个环,那么这个森林就称为伪森林。

现在给出一个森林,求森林包含的最大的伪森林,

直接按照求最大生成树的思想去搞啊

#include<iostream>
#include<cstdio>
#include<cstring>
#include<string>
#include<cmath>
#include<algorithm>
#include<cstdlib>
using namespace std;
int n,m,fa[10005];
bool vis[10005];
struct node
{
    int x,y,w;
}e[100005];
int find(int x)
{
    if(x!=fa[x])
        fa[x]=find(fa[x]);
    return fa[x];
}
bool cmp(node a,node b)
{
    return  a.w>b.w;
}
int main()
{
    while(scanf("%d%d",&n,&m)!=EOF)
    {
        if(n==0&&m==0)
            break;
        int ans=0;
        for(int i=0;i<n;i++)
            fa[i]=i,vis[i]=0;
        for(int i=1;i<=m;i++)
            scanf("%d%d%d",&e[i].x,&e[i].y,&e[i].w);
        sort(e+1,e+1+m,cmp);
        for(int i=1;i<=m;i++)
        {
            int fx,fy;
            fx=find(e[i].x),fy=find(e[i].y);
            if(fx!=fy)
            {
                if(!vis[fx]&&!vis[fy])
                {
                    ans+=e[i].w;
                    fa[fx]=fy;
                }
                else if(!vis[fx]||!vis[fy])
                {
                    ans+=e[i].w;
                    vis[fx]=vis[fy]=1;
                }
            }
            else
            {
                if(!vis[fx]&&!vis[fy])
                {
                    ans+=e[i].w;
                    vis[fx]=vis[fy]=1;
                }
            }
        }
        printf("%d\n",ans);
    }
    return 0;
}

  

时间: 2024-10-29 10:46:13

(最大生成树) hdu 3367的相关文章

HDU 3367 Pseudoforest 最大生成树

题目来源:HDU 3367 Pseudoforest 题意:每个连通块最多可以有一个环 求最大的森林 思路:考虑最大生成树 如果祖先一样没有环 那就合并 如果祖先不一样 如果2棵树都没有环 合并 如果有1棵树有环 合并 标记该棵树有环 #include <cstdio> #include <cstring> #include <algorithm> using namespace std; const int maxn = 100010; struct edge { i

HDU 3367 Pseudoforest(伪森林)(并查集)

题目连接:http://acm.hdu.edu.cn/showproblem.php?pid=3367 题意:在图论中,如果一个森林中有很多连通分量,并且每个连通分量中至多有一个环,那么这个森林就称为伪森林. 现在给出一个森林,求森林包含的最大的伪森林,其大小通过所有边的权值之和来比较. 分析: 1.一开始想的是:在每个连通分量中求一个最大生成树,然后加一条最大的边,再把每个连通分量算出来的值加起来,但WA了.这并不是最优的,因为还存在这种情况:一个连通分量里最初有两个环,但是伪森林要求最多一个

hdu 2686 Matrix &amp;&amp; hdu 3367 Matrix Again (最大费用最大流)

Matrix Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 1394    Accepted Submission(s): 758 Problem Description Yifenfei very like play a number game in the n*n Matrix. A positive integer number

hdu 3367 Pseudoforest (最小生成树)

Pseudoforest Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)Total Submission(s): 1526    Accepted Submission(s): 580 Problem Description In graph theory, a pseudoforest is an undirected graph in which every connec

HDU 3367 Hotel

参照这个博客的做法:请戳 ,还有这个的讲解: 询问区间中满足条件的连续最长区间通常属于区间合并问题. 节点增加4个域,lx:从区间左边数连续空房间的数目.rx:从区间右边数连续空房间的数目.ax:该区间中连续空房间的总数目 col:记录该区间住人的状态,1表示全住满,0表示全空,-1表示有可以住的房间. 查询是否有连续空房间数目num的时候,先查询左边,当tree[v].lx >= num的时候递归左区间:再查询中间,当tree[v*2].lx +tree[v*2+1].rx >= num直接

hdu 3367 Pseudoforest 最大生成树★

1 #include <cstdio> 2 #include <cstring> 3 #include <vector> 4 #include <algorithm> 5 using namespace std; 6 7 const int maxn = 100005; 8 int n, m; 9 struct node 10 { 11 int u, v, c; 12 }g[maxn]; 13 long long ans; 14 int fa[maxn];

HDU 3367 Pseudoforest

https://vjudge.net/problem/HDU-3367 题意: 一个伪森林是一个每个连通分量至多有一个环的无向图,给出一个图,图中不包含重边和圈,请你求出这个图的权值最大的伪森林. 思路: 一开始想的是用最大生成树,然后加一条最大的不在生成树中的边,wa了,真是可笑题意都没有理解清楚.题中的图可以是非连通的. 之后看了题解,发现是用并查集的思路,先把边从大到小进行排序,之后对于每一条边,我们看它的两个点a,b. 有2大的种情况: 1.a,b在一个连通分量中,并且他们没有被标记,则

hdu 3367 Pseudoforest(并查集)

题意:求图的一最大联通子图,其中最多包含一个环. 思路:利用求最小生成树的方法(kruskal),排序时从大到小排序.连接时有三种情况: 1.一边有环,一边没有(可能两点已经在同一集合,也可能不在) 2.两边都没有环 3.两边都有环 如图: 1 #include<iostream> 2 #include<cstdio> 3 #include<cstdlib> 4 #include<cstring> 5 #include<string> 6 #in

(最大生成树) hdu 4313

Matrix Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 2611    Accepted Submission(s): 978 Problem Description Machines have once again attacked the kingdom of Xions. The kingdom of Xions has N